//+------------------------------------------------------------------+
//|                                        AbsoluteStrength_v1.1.mq4 |
//|                           Copyright  2006, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                       E-mail: igorad2004@list.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     LimeGreen
#property indicator_width1     2 
#property indicator_color2     Red
#property indicator_width2     2
#property indicator_color3     Green
#property indicator_width3     1
#property indicator_style3     3 
#property indicator_color4     Crimson
#property indicator_width4     1 
#property indicator_style4     3
#property indicator_levelcolor MediumOrchid

//
//
//
//
//

extern string TimeFrame   = "Current time frame";
extern int    Mode        = 0;     // 0-RSI method; 1-Stoch method; 2-ADX method
extern double Length      = 10;  
extern double Signal      = 5;  
extern int    Smooth      = 5; 
extern int    Price       = 0; 
extern int    ModeMa      = 3; 
extern double OverBought  = 0; 
extern double OverSold    = 0;   
extern bool   Interpolate = true;
  
//
//
//
//
//

double SmthBulls[];
double SmthBears[];
double SigBulls[];
double SigBears[];
double Bulls[];
double Bears[];
double AvgBulls[];
double AvgBears[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{

   IndicatorBuffers(8);
   SetIndexBuffer(0,SmthBulls); SetIndexLabel(0,"Bulls");
   SetIndexBuffer(1,SmthBears); SetIndexLabel(1,"Bears");                   
   SetIndexBuffer(2,SigBulls);  SetIndexLabel(2,"SignalBulls");
   SetIndexBuffer(3,SigBears);  SetIndexLabel(3,"SignalBears");  
   SetIndexBuffer(4,Bulls);
   SetIndexBuffer(5,Bears);
   SetIndexBuffer(6,AvgBulls);
   SetIndexBuffer(7,AvgBears);
   SetLevelValue(0,0);
   
   //
   //
   //
   //
   //
       
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   calculateValue    = TimeFrame == "calculateValue"; if (calculateValue) return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
          
   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(timeFrame)+  " AbsoluteStrength ("+Mode+","+DoubleToStr(Length,2)+","+DoubleToStr(Signal,2)+")");
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { SmthBulls[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
   
     for (int i=limit; i>=0; i--)
     {
        double Price1 = getPrice(Price,i); 
        double Price2 = getPrice(Price,i+1);  
      
        if (Mode==0)
        {
           Bulls[i] = 0.5*(MathAbs(Price1-Price2)+(Price1-Price2));
           Bears[i] = 0.5*(MathAbs(Price1-Price2)-(Price1-Price2));
        }
        
        if (Mode==1)
        {
           double smax  = High[Highest(NULL,0,MODE_HIGH,Length,i)];
           double smin  =  Low[Lowest( NULL,0,MODE_LOW, Length,i)];
         
           Bulls[i] = Price1 - smin;
           Bears[i] = smax   - Price1;
        }
         
        if (Mode==2)
        {
           Bulls[i] = 0.5*(MathAbs(High[i]  - High[i+1]) + (High[i]  - High[i+1]));
           Bears[i] = 0.5*(MathAbs(Low[i+1] - Low[i])    + (Low[i+1] - Low[i]));
        }
      
      
      }
      
      //
      //
      //
      //
      //
      
      for (i = limit; i >= 0; i--)
      {
         AvgBulls[i] = iMAOnArray(Bulls,0,Length,0,ModeMa,i);     
         AvgBears[i] = iMAOnArray(Bears,0,Length,0,ModeMa,i);
      }
      
      
      for (i = limit; i >= 0; i--)
      {
         SmthBulls[i] = iMAOnArray(AvgBulls,0,Smooth,0,ModeMa,i);     
         SmthBears[i] = iMAOnArray(AvgBears,0,Smooth,0,ModeMa,i);
      }
                
      for (i = limit; i >= 0; i--)
      {
         if (OverBought > 0 && OverSold > 0 )
         {
           SigBulls[i] = OverBought/ 100 * (SmthBulls[i] + SmthBears[i]);
           SigBears[i] = OverSold  / 100 * (SmthBulls[i] + SmthBears[i]);
         }
         else
         {
           SigBulls[i] = iMAOnArray(SmthBulls,0,Signal,0,ModeMa,i);     
           SigBears[i] = iMAOnArray(SmthBears,0,Signal,0,ModeMa,i);  
         }
      }

      return(0);
      }
      
      //
      //
      //
      //
      //
      
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      for (i=limit; i>=0; i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);               
            SmthBulls[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Mode,Length,Signal,Smooth,Price,ModeMa,OverBought,OverSold,0,y);
            SmthBears[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Mode,Length,Signal,Smooth,Price,ModeMa,OverBought,OverSold,1,y);
            SigBulls[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Mode,Length,Signal,Smooth,Price,ModeMa,OverBought,OverSold,2,y);
            SigBears[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Mode,Length,Signal,Smooth,Price,ModeMa,OverBought,OverSold,3,y);
            
            //
            //
            //
            //
            //
       
            if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
            if (!Interpolate) continue;

            //
            //
            //
            //
            //

            datetime time = iTime(NULL,timeFrame,y);
               for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(int x = 1; x < n; x++)
               {
              
                  SmthBulls[i+x] = SmthBulls[i] + (SmthBulls[i+n] - SmthBulls[i]) * x/n;
                  SmthBears[i+x] = SmthBears[i] + (SmthBears[i+n] - SmthBears[i]) * x/n;
                  SigBulls[i+x]  = SigBulls[i]  + (SigBulls[i+n]  - SigBulls[i])  * x/n;
                  SigBears[i+x]  = SigBears[i]  + (SigBears[i+n]  - SigBears[i])  * x/n;
                  
               }               
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//
//
//
//
//

double getPrice(int type, int i)
{
   switch (type)
   {
      case 7:     return((Open[i]+Close[i])/2.0);
      case 8:     return((Open[i]+High[i]+Low[i]+Close[i])/4.0);
      default :   return(iMA(NULL,0,1,0,MODE_SMA,type,i));
   }      
}


